#!/bin/bash

#
# Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.
#
# SPDX-License-Identifier: Apache-2.0
#

project_name=key-service
image_name=assets-keyservice
commit_id=$(git rev-parse --short=7 HEAD)
VERSION=v2.0.0

if [[ $(pwd) == *"docker"* ]]; then
  cd ..
fi

docker stop ${image_name}
docker rm  ${image_name}
docker images | grep  ${image_name} | awk '{print $3}' | xargs docker rmi

make build-docker

# 测试的脚本，不需要打 tag
#docker rmi -f chainweaver/public-key:v2.0.0

docker run --log-opt max-size=100m --log-opt max-file=2 \
  -p 6063:6063 -p 8083:8083 --name ${image_name} \
  -v ~/deploy/scripts:/${project_name}/cert \
  -v ~/ida-projects/${project_name}/logs:/${project_name}/logs \
  -d 192.168.1.181:5000/ida/${image_name}-${commit_id}:${VERSION}

docker ps

docker push 192.168.1.181:5000/ida/${image_name}-${commit_id}:${VERSION}
docker push docker.oa.com:5000/chainweaver/public-key:${VERSION}
docker push 192.168.1.181:5000/chainweaver/public-key:${VERSION}