package csp

import (
	"testing"

	internal_config "chainweaver.org.cn/chainweaver/ida/key-service/v2/internal/config"
)

func TestInitCrypto(t *testing.T) {
	type args struct {
		cfg *internal_config.Config
	}
	tests := []struct {
		name    string
		args    args
		want    CSP
		wantErr bool
	}{
		{
			name: "success",
			args: args{
				cfg: &internal_config.Config{
					CryptoConfig: internal_config.CryptoConfig{
						Soft: true,
					},
				},
			},
		},
	}
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			got, err := InitCrypto(tt.args.cfg)
			if (err != nil) != tt.wantErr {
				t.Errorf("InitCrypto() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if got == nil {
				t.Errorf("InitCrypto() got = %v, want %v", got, tt.want)
			}
		})
	}
}
