/*
Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.

SPDX-License-Identifier: Apache-2.0
*/

package kms

import "encoding/json"

// Key 外接 kms 的 key 结构
type Key struct {
	CertId        int    `json:"certId"`
	KeyId         string `json:"keyId"`
	KeySecret     string `json:"keySecret"`
	Algorithm     string `json:"algorithm"`
	KmsAdapterUrl string `json:"kmsAdapterUrl"`
}

// Unmarshal 解析 keyJson 字符串
func (k *Key) Unmarshal(keyJson []byte) error {
	return json.Unmarshal(keyJson, k)
}

// Marshal 序列化 key 对象
func (k *Key) Marshal() ([]byte, error) {
	return json.Marshal(k)
}
