/*
Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.

SPDX-License-Identifier: Apache-2.0
*/

package kms

import "testing"

func TestKey_Marshal(t *testing.T) {
	k := &Key{
		CertId:        1426063379,
		KeyId:         "3da0a8885c81407093e8a8387166cace",
		KeySecret:     "0e997edddea74a749b49016d285012d6",
		Algorithm:     "SM3WITHSM2",
		KmsAdapterUrl: "kms-adapter.public:8180",
	}
	kBytes, err := k.Marshal()
	if err != nil {
		t.Error(err)
	}

	t.Logf("\n\n kms key marshal result: %s \n\n", string(kBytes))
}

func TestKey_Unmarshal(t *testing.T) {
	/* #nosec */
	keyJson := "{\"certId\":1426063379,\"keyId\":\"3da0a8885c81407093e8a8387166cace\",\"keySecret\":\"0e997edddea74a749b49016d285012d6\",\"algorithm\":\"SM3WITHSM2\",\"kmsAdapterUrl\":\"kms-adapter.public:8180\"}"
	var k Key
	err := k.Unmarshal([]byte(keyJson))
	if err != nil {
		t.Error(err)
	}

	t.Logf("\n\n kms key unmarshal result: %#v \n\n", k)
}
