/*
Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.

SPDX-License-Identifier: Apache-2.0
*/

// Package table 表结构定义
package table

import (
	"time"
)

// AuthUser 私钥授权用户表
// nolint:lll
type AuthUser struct {
	Id        uint      `gorm:"column:id;primary_key;AUTO_INCREMENT;comment:主键Id" json:"id"`
	KeyId     uint      `gorm:"column:key_id;comment:私钥id;NOT NULL" json:"key_id"`
	UserId    uint32    `gorm:"column:user_id;comment:用户id;NOT NULL" json:"user_id"`
	UserName  string    `gorm:"column:user_name;type:varchar(64);comment:用户名称;NOT NULL" json:"user_name"`
	CreatedAt time.Time `gorm:"column:created_at;autoCreateTime;default:CURRENT_TIMESTAMP;comment:创建时间" json:"created_at"`
	UpdatedAt time.Time `gorm:"column:updated_at;autoUpdateTime;default:CURRENT_TIMESTAMP;comment:更新时间" json:"updated_at"`
	KeyInfo   KeyInfo   `gorm:"foreignKey:KeyId"`
}

// TableName 表名称
func (m *AuthUser) TableName() string {
	return "auth_user"
}
