// Code generated by goctl. DO NOT EDIT.
// Source: key.proto

package server

import (
	"context"

	"chainweaver.org.cn/chainweaver/ida/key-service/v2/internal/logic"
	"chainweaver.org.cn/chainweaver/ida/key-service/v2/internal/svc"
	"chainweaver.org.cn/chainweaver/ida/key-service/v2/pb/keypb"
)

type KeyServer struct {
	svcCtx *svc.ServiceContext
	keypb.UnimplementedKeyServer
}

func NewKeyServer(svcCtx *svc.ServiceContext) *KeyServer {
	return &KeyServer{
		svcCtx: svcCtx,
	}
}

// 导入私钥
func (s *KeyServer) ImportKey(ctx context.Context, in *keypb.ImportKeyRequest) (*keypb.ImportKeyResponse, error) {
	l := logic.NewImportKeyLogic(ctx, s.svcCtx)
	return l.ImportKey(in)
}

// 保存链账户配置
func (s *KeyServer) AccountConfig(ctx context.Context, in *keypb.AccountConfigRequest) (*keypb.AccountConfigResponse, error) {
	l := logic.NewAccountConfigLogic(ctx, s.svcCtx)
	return l.AccountConfig(in)
}

// 链账户列表
func (s *KeyServer) ListAccount(ctx context.Context, in *keypb.ListAccountRequest) (*keypb.ListAccountResponse, error) {
	l := logic.NewListAccountLogic(ctx, s.svcCtx)
	return l.ListAccount(in)
}

// 链账户详情
func (s *KeyServer) GetAccountDetail(ctx context.Context, in *keypb.GetAccountDetailRequest) (*keypb.GetAccountDetailResponse, error) {
	l := logic.NewGetAccountDetailLogic(ctx, s.svcCtx)
	return l.GetAccountDetail(in)
}

// 签名
func (s *KeyServer) Sign(ctx context.Context, in *keypb.SignRequest) (*keypb.SignResponse, error) {
	l := logic.NewSignLogic(ctx, s.svcCtx)
	return l.Sign(in)
}

// 删除私钥和证书
func (s *KeyServer) DeleteKeyAndCert(ctx context.Context, in *keypb.DeleteKeyAndCertRequest) (*keypb.DeleteKeyAndCertResponse, error) {
	l := logic.NewDeleteKeyAndCertLogic(ctx, s.svcCtx)
	return l.DeleteKeyAndCert(in)
}

// 查询账户信息：区块链 id、账户名称、账户类型等
func (s *KeyServer) GetAccountInfo(ctx context.Context, in *keypb.GetAccountInfoRequest) (*keypb.GetAccountInfoResponse, error) {
	l := logic.NewGetAccountInfoLogic(ctx, s.svcCtx)
	return l.GetAccountInfo(in)
}

// 获取 did 信息
func (s *KeyServer) GetDidInfo(ctx context.Context, in *keypb.GetDidInfoRequest) (*keypb.GetDidInfoResponse, error) {
	l := logic.NewGetDidInfoLogic(ctx, s.svcCtx)
	return l.GetDidInfo(in)
}

// 生成密钥
func (s *KeyServer) CreateKey(ctx context.Context, in *keypb.KeyCreateRequest) (*keypb.KeyCreateResponse, error) {
	l := logic.NewCreateKeyLogic(ctx, s.svcCtx)
	return l.CreateKey(in)
}

// 加密
func (s *KeyServer) Encrypt(ctx context.Context, in *keypb.KeyEncryptRequest) (*keypb.KeyEncryptResponse, error) {
	l := logic.NewEncryptLogic(ctx, s.svcCtx)
	return l.Encrypt(in)
}

// 传入多个公钥，对同一个明文加密
func (s *KeyServer) EncryptWithPkList(ctx context.Context, in *keypb.KeyEncryptWithPkListRequest) (*keypb.KeyEncryptWithPkListResponse, error) {
	l := logic.NewEncryptWithPkListLogic(ctx, s.svcCtx)
	return l.EncryptWithPkList(in)
}

// 解密
func (s *KeyServer) Decrypt(ctx context.Context, in *keypb.KeyDecryptRequest) (*keypb.KeyDecryptResponse, error) {
	l := logic.NewDecryptLogic(ctx, s.svcCtx)
	return l.Decrypt(in)
}

// 数字信封加密
func (s *KeyServer) EncWithDeK(ctx context.Context, in *keypb.DataEnvelopeEncryptRequest) (*keypb.DataEnvelopeEncryptResponse, error) {
	l := logic.NewEncWithDeKLogic(ctx, s.svcCtx)
	return l.EncWithDeK(in)
}

// 数字信封解密
func (s *KeyServer) DecByKeK(ctx context.Context, in *keypb.DataEnvelopeDecryptRequest) (*keypb.KeyDecryptResponse, error) {
	l := logic.NewDecByKeKLogic(ctx, s.svcCtx)
	return l.DecByKeK(in)
}

// 数字信封传入多个公钥，对同一个明文加密
func (s *KeyServer) EncWithDeKWithPkList(ctx context.Context, in *keypb.DataEnvelopeEncryptWithPkListRequest) (*keypb.DataEnvelopeEncryptWithPkListResponse, error) {
	l := logic.NewEncWithDeKWithPkListLogic(ctx, s.svcCtx)
	return l.EncWithDeKWithPkList(in)
}

// 根据公钥获取私钥
func (s *KeyServer) GetSkFromPk(ctx context.Context, in *keypb.GetSkRequest) (*keypb.GetSkResponse, error) {
	l := logic.NewGetSkFromPkLogic(ctx, s.svcCtx)
	return l.GetSkFromPk(in)
}

// 根据 keyId 获取私钥
func (s *KeyServer) GetSkFromKeyId(ctx context.Context, in *keypb.GetSkFromKeyIdRequest) (*keypb.GetSkResponse, error) {
	l := logic.NewGetSkFromKeyIdLogic(ctx, s.svcCtx)
	return l.GetSkFromKeyId(in)
}
