// Code generated by goctl. DO NOT EDIT.
// Source: key.proto

package key

import (
	"context"

	"chainweaver.org.cn/chainweaver/ida/key-service/v2/pb/keypb"

	"github.com/zeromicro/go-zero/zrpc"
	"google.golang.org/grpc"
)

type (
	AccountConfigRequest                  = keypb.AccountConfigRequest
	AccountConfigResponse                 = keypb.AccountConfigResponse
	AccountData                           = keypb.AccountData
	DataEnvelopeDecryptRequest            = keypb.DataEnvelopeDecryptRequest
	DataEnvelopeEncryptRequest            = keypb.DataEnvelopeEncryptRequest
	DataEnvelopeEncryptResponse           = keypb.DataEnvelopeEncryptResponse
	DataEnvelopeEncryptWithPkListRequest  = keypb.DataEnvelopeEncryptWithPkListRequest
	DataEnvelopeEncryptWithPkListResponse = keypb.DataEnvelopeEncryptWithPkListResponse
	DeleteKeyAndCertRequest               = keypb.DeleteKeyAndCertRequest
	DeleteKeyAndCertResponse              = keypb.DeleteKeyAndCertResponse
	DidInfoData                           = keypb.DidInfoData
	GetAccountDetailRequest               = keypb.GetAccountDetailRequest
	GetAccountDetailResponse              = keypb.GetAccountDetailResponse
	GetAccountInfoRequest                 = keypb.GetAccountInfoRequest
	GetAccountInfoResponse                = keypb.GetAccountInfoResponse
	GetDidInfoRequest                     = keypb.GetDidInfoRequest
	GetDidInfoResponse                    = keypb.GetDidInfoResponse
	GetSkFromKeyIdRequest                 = keypb.GetSkFromKeyIdRequest
	GetSkRequest                          = keypb.GetSkRequest
	GetSkResponse                         = keypb.GetSkResponse
	ImportKeyRequest                      = keypb.ImportKeyRequest
	ImportKeyResponse                     = keypb.ImportKeyResponse
	KeyCreateRequest                      = keypb.KeyCreateRequest
	KeyCreateResponse                     = keypb.KeyCreateResponse
	KeyDecryptRequest                     = keypb.KeyDecryptRequest
	KeyDecryptResponse                    = keypb.KeyDecryptResponse
	KeyEncryptRequest                     = keypb.KeyEncryptRequest
	KeyEncryptResponse                    = keypb.KeyEncryptResponse
	KeyEncryptWithPkListRequest           = keypb.KeyEncryptWithPkListRequest
	KeyEncryptWithPkListResponse          = keypb.KeyEncryptWithPkListResponse
	ListAccountRequest                    = keypb.ListAccountRequest
	ListAccountResponse                   = keypb.ListAccountResponse
	ListAccountResponse_ListAccountData   = keypb.ListAccountResponse_ListAccountData
	SignRequest                           = keypb.SignRequest
	SignResponse                          = keypb.SignResponse
	SignResponseSignData                  = keypb.SignResponseSignData
	SignResponse_Member                   = keypb.SignResponse_Member

	Key interface {
		// 导入私钥
		ImportKey(ctx context.Context, in *ImportKeyRequest, opts ...grpc.CallOption) (*ImportKeyResponse, error)
		// 保存链账户配置
		AccountConfig(ctx context.Context, in *AccountConfigRequest, opts ...grpc.CallOption) (*AccountConfigResponse, error)
		// 链账户列表
		ListAccount(ctx context.Context, in *ListAccountRequest, opts ...grpc.CallOption) (*ListAccountResponse, error)
		// 链账户详情
		GetAccountDetail(ctx context.Context, in *GetAccountDetailRequest, opts ...grpc.CallOption) (*GetAccountDetailResponse, error)
		// 签名
		Sign(ctx context.Context, in *SignRequest, opts ...grpc.CallOption) (*SignResponse, error)
		// 删除私钥和证书
		DeleteKeyAndCert(ctx context.Context, in *DeleteKeyAndCertRequest, opts ...grpc.CallOption) (*DeleteKeyAndCertResponse, error)
		// 查询账户信息：区块链 id、账户名称、账户类型等
		GetAccountInfo(ctx context.Context, in *GetAccountInfoRequest, opts ...grpc.CallOption) (*GetAccountInfoResponse, error)
		// 获取 did 信息
		GetDidInfo(ctx context.Context, in *GetDidInfoRequest, opts ...grpc.CallOption) (*GetDidInfoResponse, error)
		// 生成密钥
		CreateKey(ctx context.Context, in *KeyCreateRequest, opts ...grpc.CallOption) (*KeyCreateResponse, error)
		// 加密
		Encrypt(ctx context.Context, in *KeyEncryptRequest, opts ...grpc.CallOption) (*KeyEncryptResponse, error)
		// 传入多个公钥，对同一个明文加密
		EncryptWithPkList(ctx context.Context, in *KeyEncryptWithPkListRequest, opts ...grpc.CallOption) (*KeyEncryptWithPkListResponse, error)
		// 解密
		Decrypt(ctx context.Context, in *KeyDecryptRequest, opts ...grpc.CallOption) (*KeyDecryptResponse, error)
		// 数字信封加密
		EncWithDeK(ctx context.Context, in *DataEnvelopeEncryptRequest, opts ...grpc.CallOption) (*DataEnvelopeEncryptResponse, error)
		// 数字信封解密
		DecByKeK(ctx context.Context, in *DataEnvelopeDecryptRequest, opts ...grpc.CallOption) (*KeyDecryptResponse, error)
		// 数字信封传入多个公钥，对同一个明文加密
		EncWithDeKWithPkList(ctx context.Context, in *DataEnvelopeEncryptWithPkListRequest, opts ...grpc.CallOption) (*DataEnvelopeEncryptWithPkListResponse, error)
		// 根据公钥获取私钥
		GetSkFromPk(ctx context.Context, in *GetSkRequest, opts ...grpc.CallOption) (*GetSkResponse, error)
		// 根据 keyId 获取私钥
		GetSkFromKeyId(ctx context.Context, in *GetSkFromKeyIdRequest, opts ...grpc.CallOption) (*GetSkResponse, error)
	}

	defaultKey struct {
		cli zrpc.Client
	}
)

func NewKey(cli zrpc.Client) Key {
	return &defaultKey{
		cli: cli,
	}
}

// 导入私钥
func (m *defaultKey) ImportKey(ctx context.Context, in *ImportKeyRequest, opts ...grpc.CallOption) (*ImportKeyResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.ImportKey(ctx, in, opts...)
}

// 保存链账户配置
func (m *defaultKey) AccountConfig(ctx context.Context, in *AccountConfigRequest, opts ...grpc.CallOption) (*AccountConfigResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.AccountConfig(ctx, in, opts...)
}

// 链账户列表
func (m *defaultKey) ListAccount(ctx context.Context, in *ListAccountRequest, opts ...grpc.CallOption) (*ListAccountResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.ListAccount(ctx, in, opts...)
}

// 链账户详情
func (m *defaultKey) GetAccountDetail(ctx context.Context, in *GetAccountDetailRequest, opts ...grpc.CallOption) (*GetAccountDetailResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.GetAccountDetail(ctx, in, opts...)
}

// 签名
func (m *defaultKey) Sign(ctx context.Context, in *SignRequest, opts ...grpc.CallOption) (*SignResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.Sign(ctx, in, opts...)
}

// 删除私钥和证书
func (m *defaultKey) DeleteKeyAndCert(ctx context.Context, in *DeleteKeyAndCertRequest, opts ...grpc.CallOption) (*DeleteKeyAndCertResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.DeleteKeyAndCert(ctx, in, opts...)
}

// 查询账户信息：区块链 id、账户名称、账户类型等
func (m *defaultKey) GetAccountInfo(ctx context.Context, in *GetAccountInfoRequest, opts ...grpc.CallOption) (*GetAccountInfoResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.GetAccountInfo(ctx, in, opts...)
}

// 获取 did 信息
func (m *defaultKey) GetDidInfo(ctx context.Context, in *GetDidInfoRequest, opts ...grpc.CallOption) (*GetDidInfoResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.GetDidInfo(ctx, in, opts...)
}

// 生成密钥
func (m *defaultKey) CreateKey(ctx context.Context, in *KeyCreateRequest, opts ...grpc.CallOption) (*KeyCreateResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.CreateKey(ctx, in, opts...)
}

// 加密
func (m *defaultKey) Encrypt(ctx context.Context, in *KeyEncryptRequest, opts ...grpc.CallOption) (*KeyEncryptResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.Encrypt(ctx, in, opts...)
}

// 传入多个公钥，对同一个明文加密
func (m *defaultKey) EncryptWithPkList(ctx context.Context, in *KeyEncryptWithPkListRequest, opts ...grpc.CallOption) (*KeyEncryptWithPkListResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.EncryptWithPkList(ctx, in, opts...)
}

// 解密
func (m *defaultKey) Decrypt(ctx context.Context, in *KeyDecryptRequest, opts ...grpc.CallOption) (*KeyDecryptResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.Decrypt(ctx, in, opts...)
}

// 数字信封加密
func (m *defaultKey) EncWithDeK(ctx context.Context, in *DataEnvelopeEncryptRequest, opts ...grpc.CallOption) (*DataEnvelopeEncryptResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.EncWithDeK(ctx, in, opts...)
}

// 数字信封解密
func (m *defaultKey) DecByKeK(ctx context.Context, in *DataEnvelopeDecryptRequest, opts ...grpc.CallOption) (*KeyDecryptResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.DecByKeK(ctx, in, opts...)
}

// 数字信封传入多个公钥，对同一个明文加密
func (m *defaultKey) EncWithDeKWithPkList(ctx context.Context, in *DataEnvelopeEncryptWithPkListRequest, opts ...grpc.CallOption) (*DataEnvelopeEncryptWithPkListResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.EncWithDeKWithPkList(ctx, in, opts...)
}

// 根据公钥获取私钥
func (m *defaultKey) GetSkFromPk(ctx context.Context, in *GetSkRequest, opts ...grpc.CallOption) (*GetSkResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.GetSkFromPk(ctx, in, opts...)
}

// 根据 keyId 获取私钥
func (m *defaultKey) GetSkFromKeyId(ctx context.Context, in *GetSkFromKeyIdRequest, opts ...grpc.CallOption) (*GetSkResponse, error) {
	client := keypb.NewKeyClient(m.cli.Conn())
	return client.GetSkFromKeyId(ctx, in, opts...)
}
