#!/bin/bash

#
# Copyright (C) THL A29 Limited, a Tencent company. All rights reserved.
#
# SPDX-License-Identifier: Apache-2.0
#

PROJECT_NAME=$1
SERVER_NAME=$2
PB_DIR=$3

#PROJECT_NAME="registration-service"
#SERVER_NAME="registration"
#SERVER_CLIENT="registrationclient"
#PB_DIR="registrationpb"

cp ../common/pb/commonpb/common.proto ./proto/common.proto

protoc --go_out=./pb --go-grpc_out=./pb ./proto/common.proto
protoc --go_out=./pb --go-grpc_out=./pb ./proto/${SERVER_NAME}.proto

rm -rf ./pb
goctl rpc protoc --go_out=./pb --go-grpc_out=./pb --zrpc_out=. ./proto/${SERVER_NAME}.proto >> /dev/null
protoc --include_imports --proto_path=. --descriptor_set_out=./pb/key.pb ./proto/key-api.proto
rm -rf ./scripts/internal

sed -i '' "s/\.\/commonpb/chainweaver.org.cn\/chainweaver\/ida\/common\/v2\/pb\/commonpb/g" ./pb/${PB_DIR}/*

#sed -i '' "/\"chainweaver.org.cn\/chainweaver\/ida\/${PROJECT_NAME}\/v2\/pb\/${PB_DIR}\"/a\\
#\"chainweaver.org.cn\/chainweaver\/ida\/common\/v2\/pb\/commonpb\"" ./${SERVER_NAME}/*
#
#sed -i '' "/\"chainweaver.org.cn\/chainweaver\/ida\/${PROJECT_NAME}\/v2\/pb\/${PB_DIR}\"/a\\
#\"chainweaver.org.cn\/chainweaver\/ida\/common\/v2\/pb\/commonpb\"" ./internal/server/*

#sed -i '' "/\"chainweaver.org.cn\/chainweaver\/ida\/${PROJECT_NAME}\/v2\/pb\/${PB_DIR}\"/a\\
#\"chainweaver.org.cn\/chainweaver\/ida\/common\/v2\/pb\/commonpb\"" ./internal/logic/*

# 获取所有的 message 名称
messages=$(grep -a "message" ./proto/common.proto | cut -d  " " -f 2)

# 遍历所有的 message 名称
for message in $messages
do
  # 使用 sed 命令替换 文件中的 common object
  sed -i '' "s/\*$message,/\*commonpb\.$message,/g" ./${SERVER_NAME}/*
  sed -i '' "s/${PB_DIR}\.$message/\commonpb\.$message/g" ./internal/server/*
  sed -i '' "s/${PB_DIR}\.$message/\commonpb\.$message/g" ./internal/logic/*
done

rm -rf ./pb/commonpb

go fmt ./${SERVER_NAME}/* >> /dev/null
#go fmt ./internal/logic/* >> /dev/null
#go fmt ./internal/server/* >> /dev/null
