CREATE TABLE IF NOT EXISTS  `key_info` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键Id',
    `chain_id` varchar(64) NOT NULL COMMENT '区块链id',
    `sub_chain_id` varchar(64) COMMENT '子链id',
    `chain_name` varchar(64) NOT NULL COMMENT '区块链名称',
    `key_mode` ENUM('KEY_MODE_CERT', 'KEY_MODE_PK') NOT NULL COMMENT '私钥模式',
    `key_cipher` blob NOT NULL COMMENT '私钥密文',
    `key_file_name` varchar(64) NOT NULL COMMENT '私钥文件名称',
    `key_file_type` varchar(64) NOT NULL COMMENT '私钥文件类型',
    `cert_cipher` blob COMMENT '证书密文',
    `cert_file_name` varchar(64) COMMENT '证书文件名称',
    `cert_file_type` varchar(64) COMMENT '证书文件类型',
    `account_address` varchar(64) NOT NULL COMMENT '链账户地址',
    `account_name` varchar(64) NOT NULL COMMENT '链账户身份',
    `account_social_credit_code` varchar(64) NOT NULL COMMENT '社会信用代码',
    `account_type` varchar(64) NOT NULL COMMENT '账户类型',
    `register_id` int(10) unsigned NOT NULL COMMENT '链上注册Id',
    `status` ENUM('KEY_STATUS_ENABLE', 'KEY_STATUS_DISABLE') NOT NULL COMMENT '私钥状态',
    `created_at` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `updated_at` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',

    PRIMARY KEY (`id`)

) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT="私钥信息表";

CREATE TABLE IF NOT EXISTS  `auth_user` (
    `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键Id',
    `key_id` int(10) unsigned NOT NULL COMMENT '私钥id',
    `user_id` int(10) unsigned NOT NULL COMMENT '用户id',
    `user_name` varchar(64) NOT NULL COMMENT '用户名称',
    `created_at` datetime DEFAULT CURRENT_TIMESTAMP COMMENT '创建时间',
    `updated_at` datetime DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP COMMENT '更新时间',

    PRIMARY KEY (`id`),
    KEY `key_id_idx` (`key_id`),
    CONSTRAINT `key_id` FOREIGN KEY (`key_id`) REFERENCES `key_info` (`id`)

) ENGINE=InnoDB AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT="私钥授权用户表";